﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using com.citizen.sdk;
using com.citizen.sdk.poslayout;

//-------------------------------------------------------------------------------
// (C) 2017 CITIZEN SYSTEMS JAPAN CO., LTD. All Rights Reserved.
//-------------------------------------------------------------------------------
namespace ReceiptPrint
{
	public partial class Form_PrintOption : Form
	{
		// #01
		List<KeyValuePair<int, string>> MapModeList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_MM_METRIC, "1/100 mm"), 
			new KeyValuePair<int, string>(LPEConst.CPE_MM_ENGLISH, "1/1000 inch"), 
		};
		// #02
		List<KeyValuePair<int, string>> HalftoneList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_HT_THRESHOLD, "Threshold"), 
			new KeyValuePair<int, string>(LPEConst.CPE_HT_DITHER, "Dither"), 
		};
		// #03
		List<KeyValuePair<int, string>> ColorModeList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_CMD_MONO, "Monochrome"), 
			new KeyValuePair<int, string>(LPEConst.CPE_CMD_GRAY, "Grayscale"), 
		};
		// #04
		List<KeyValuePair<int, string>> PaperMediaList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_PAPER_NORMAL, "Normal"), 
			new KeyValuePair<int, string>(LPEConst.CPE_PAPER_LABEL_BM, "Label/BM"), 
		};
		// #05
		List<KeyValuePair<int, string>> CutterModeList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_CUT_NONE, "No Cut"), 
			new KeyValuePair<int, string>(LPEConst.CPE_CUT_PARTIAL, "Partial Cut"), 
			new KeyValuePair<int, string>(LPEConst.CPE_CUT_FULL, "Full Cut"), 
		};
		// #06
		List<KeyValuePair<int, string>> PaperFeedList = new List<KeyValuePair<int, string>>() {
		};
		// #07, #08
		List<KeyValuePair<int, string>> DrawerOpenList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_DRAWER_NEVER, "Never"), 
			new KeyValuePair<int, string>(LPEConst.CPE_DRAWER_START, "Print Start"), 
			new KeyValuePair<int, string>(LPEConst.CPE_DRAWER_END, "Print End"), 
		};
		// #09, #10
		List<KeyValuePair<int, string>> PulseWidthList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(1, "100 [ms]"), 
			new KeyValuePair<int, string>(2, "200 [ms]"), 
			new KeyValuePair<int, string>(3, "300 [ms]"), 
			new KeyValuePair<int, string>(4, "400 [ms]"), 
			new KeyValuePair<int, string>(5, "500 [ms]"), 
			new KeyValuePair<int, string>(6, "600 [ms]"), 
			new KeyValuePair<int, string>(7, "700 [ms]"), 
			new KeyValuePair<int, string>(8, "800 [ms]"), 
		};
		// #11, #12
		List<KeyValuePair<int, string>> BuzzerList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(0, "0 [times]"), 
			new KeyValuePair<int, string>(1, "1 [times]"), 
			new KeyValuePair<int, string>(2, "2 [times]"), 
			new KeyValuePair<int, string>(3, "3 [times]"), 
			new KeyValuePair<int, string>(4, "4 [times]"), 
			new KeyValuePair<int, string>(5, "5 [times]"), 
			new KeyValuePair<int, string>(6, "6 [times]"), 
			new KeyValuePair<int, string>(7, "7 [times]"), 
			new KeyValuePair<int, string>(8, "8 [times]"), 
			new KeyValuePair<int, string>(9, "9 [times]"), 
		};
		// #13, #14
		List<KeyValuePair<int, string>> LogoList = new List<KeyValuePair<int, string>>() {
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_NONE, "None"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT01, "#01"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT02, "#02"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT03, "#03"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT04, "#04"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT05, "#05"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT06, "#06"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT07, "#07"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT08, "#08"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT09, "#09"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT10, "#10"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT11, "#11"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT12, "#12"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT13, "#13"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT14, "#14"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT15, "#15"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT16, "#16"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT17, "#17"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT18, "#18"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT19, "#19"), 
			new KeyValuePair<int, string>(LPEConst.CPE_LOGO_PRINT20, "#20"), 
		};

		public Form_PrintOption()
		{
			InitializeComponent();
		}

		public com.citizen.sdk.poslayout.PrintOption getPrintOption()
		{
			com.citizen.sdk.poslayout.PrintOption option = new com.citizen.sdk.poslayout.PrintOption();
			try
			{
				// #01
				option.MapMode = (int)comboBox_MapMode.SelectedValue;
				// #02
				option.Halftone = (int)comboBox_Halftone.SelectedValue;
				// #03
				option.ColorMode = (int)comboBox_ColorMode.SelectedValue;
				// #04
				option.PaperMedia = (int)comboBox_PaperMedia.SelectedValue;
				// #05
				option.CutterMode = (int)comboBox_CutterMode.SelectedValue;
				// #06
				option.PaperFeed = (int)numericUpDown_PaperFeed.Value;
				// #07
				option.DrawerOpen1 = (int)comboBox_DrawerOpen1.SelectedValue;
				// #08
				option.DrawerOpen2 = (int)comboBox_DrawerOpen2.SelectedValue;
				// #09
				option.PulseWidth1 = (int)comboBox_PulseWidth1.SelectedValue;
				// #10
				option.PulseWidth2 = (int)comboBox_PulseWidth2.SelectedValue;
				// #11
				option.BuzzerStart = (int)comboBox_BuzzerStart.SelectedValue;
				// #12
				option.BuzzerEnd = (int)comboBox_BuzzerEnd.SelectedValue;
				// #13
				option.LogoStart = (int)comboBox_LogoStart.SelectedValue;
				// #14
				option.LogoEnd = (int)comboBox_LogoEnd.SelectedValue;
			}
			catch (System.Exception ex)
			{
				Console.WriteLine(ex);
			}
			return option;
		}
		public void setPrintOption(com.citizen.sdk.poslayout.PrintOption option)
		{
			if (option == null)
			{
				option = new com.citizen.sdk.poslayout.PrintOption();
			}
			try
			{
				// #01
				comboBox_MapMode.DataSource = new BindingSource(MapModeList, null);
				comboBox_MapMode.DisplayMember = "value";
				comboBox_MapMode.ValueMember = "key";
				comboBox_MapMode.SelectedValue = option.MapMode;
				// #02
				comboBox_Halftone.DataSource = new BindingSource(HalftoneList, null);
				comboBox_Halftone.DisplayMember = "value";
				comboBox_Halftone.ValueMember = "key";
				comboBox_Halftone.SelectedValue = option.Halftone;
				// #03
				comboBox_ColorMode.DataSource = new BindingSource(ColorModeList, null);
				comboBox_ColorMode.DisplayMember = "value";
				comboBox_ColorMode.ValueMember = "key";
				comboBox_ColorMode.SelectedValue = option.ColorMode;
				// #04
				comboBox_PaperMedia.DataSource = new BindingSource(PaperMediaList, null);
				comboBox_PaperMedia.DisplayMember = "value";
				comboBox_PaperMedia.ValueMember = "key";
				comboBox_PaperMedia.SelectedValue = option.PaperMedia;
				// #05
				comboBox_CutterMode.DataSource = new BindingSource(CutterModeList, null);
				comboBox_CutterMode.DisplayMember = "value";
				comboBox_CutterMode.ValueMember = "key";
				comboBox_CutterMode.SelectedValue = option.CutterMode;
				// #06
				numericUpDown_PaperFeed.Value = option.PaperFeed;
				// #07
				comboBox_DrawerOpen1.DataSource = new BindingSource(DrawerOpenList, null);
				comboBox_DrawerOpen1.DisplayMember = "value";
				comboBox_DrawerOpen1.ValueMember = "key";
				comboBox_DrawerOpen1.SelectedValue = option.DrawerOpen1;
				// #08
				comboBox_DrawerOpen2.DataSource = new BindingSource(DrawerOpenList, null);
				comboBox_DrawerOpen2.DisplayMember = "value";
				comboBox_DrawerOpen2.ValueMember = "key";
				comboBox_DrawerOpen2.SelectedValue = option.DrawerOpen2;
				// #09
				comboBox_PulseWidth1.DataSource = new BindingSource(PulseWidthList, null);
				comboBox_PulseWidth1.DisplayMember = "value";
				comboBox_PulseWidth1.ValueMember = "key";
				comboBox_PulseWidth1.SelectedValue = option.PulseWidth1;
				// #10
				comboBox_PulseWidth2.DataSource = new BindingSource(PulseWidthList, null);
				comboBox_PulseWidth2.DisplayMember = "value";
				comboBox_PulseWidth2.ValueMember = "key";
				comboBox_PulseWidth2.SelectedValue = option.PulseWidth2;
				// #11
				comboBox_BuzzerStart.DataSource = new BindingSource(BuzzerList, null);
				comboBox_BuzzerStart.DisplayMember = "value";
				comboBox_BuzzerStart.ValueMember = "key";
				comboBox_BuzzerStart.SelectedValue = option.BuzzerStart;
				// #12
				comboBox_BuzzerEnd.DataSource = new BindingSource(BuzzerList, null);
				comboBox_BuzzerEnd.DisplayMember = "value";
				comboBox_BuzzerEnd.ValueMember = "key";
				comboBox_BuzzerEnd.SelectedValue = option.BuzzerEnd;
				// #13
				comboBox_LogoStart.DataSource = new BindingSource(LogoList, null);
				comboBox_LogoStart.DisplayMember = "value";
				comboBox_LogoStart.ValueMember = "key";
				comboBox_LogoStart.SelectedValue = option.LogoStart;
				// #14
				comboBox_LogoEnd.DataSource = new BindingSource(LogoList, null);
				comboBox_LogoEnd.DisplayMember = "value";
				comboBox_LogoEnd.ValueMember = "key";
				comboBox_LogoEnd.SelectedValue = option.LogoEnd;
			}
			catch (System.Exception ex)
			{
				Console.WriteLine(ex);
			}
		}
	}
}
